module td_exp_m
  use td_exp_split_m

  implicit none

  private
  public ::   &
    td_exp_t, &
    td_exp_dt

  type td_exp_t
    integer :: exp_method  ! which method is used to apply the exponential
    real(8) :: lanczos_tol ! tolerance for the lanczos method
    integer :: exp_order   ! order to which the propagator is expanded
    type(zcf_t) :: cf      ! auxiliary cube for split operator methods
  end type td_exp_t


contains

  ! ---------------------------------------------------------
  subroutine td_exp_dt(gr, h, zpsi, te)
    type(grid_t),        intent(inout) :: gr
    type(hamiltonian_t), intent(inout) :: h
    complex(8),          intent(inout) :: zpsi(:, :)
    type(td_exp_t),      intent(inout) :: te

    real(8) :: dt(5)
    integer :: k
      
    do k = 1, 5
      call zexp_kinetic(gr, h, zpsi, te%cf, -(0.0_8,1.0_8)*dt(k))
    end do

  end subroutine td_exp_dt

end module td_exp_m
